/******************************************************************
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Copyright:
 * Georg Schild (dangertools@gmail.com)
 * Franz Endstrasser (franz.endstrasser@gmail.com)
 ******************************************************************/

package org.x4x;

import org.x4x.gui.MainGUI;
import org.x4x.statics.StaticValues;

public class X4X {	
	private static String[] handleArgs(String[] args){
		int startAt = 0;
		String configFile = "";
		if (args.length > 0){
			if (args[0].equals("-v") || args[0].equals("--version")){
				System.out.println(MainGUI.version);
				return null;
			}
			else if (args[0].equals("-c") || args[0].equals("--config")){
				startAt += 2;
				configFile = args[1];
			}
			else if (args[0].equals("-h") || args[0].equals("--help")){
				System.out.println(
						"X4X - A XMMS2 client\n\n" +
						"usage X4X [options] [--clean] [filenames/playlistnames]\n\n" +
						"\t-c, --config\tset another configfile\n" +
						"\t\t(default: ${user.home}/.xmms2/clients/x4x/settings.properties)\n" +
						"\t-v, --version\tprint version\n" +
						"\t-h, --help\tprint this screen\n\n" +
						"For more infos visit http://x4x.sourceforge.net or #x4x on irc.freenode.net\n");
				return null;
			}
		}
		StaticValues.init(configFile);
		String newArgs[] = new String[args.length-startAt];
		int j = 0;
		for ( int i = startAt; i < newArgs.length; i++)
			newArgs[j++] = args[i];
		return newArgs;
	}
	
	public static void main(String[] args) {
		String x4xArgs[];
		if ((x4xArgs = handleArgs(args)) != null){
			new MainGUI(x4xArgs).open();
		}
		System.exit(0);
	}

}
