/******************************************************************
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Copyright:
 * Georg Schild (dangertools@gmail.com)
 * Franz Endstrasser (franz.endstrasser@gmail.com)
 ******************************************************************/

package org.x4x.gui;

import java.util.HashMap;

import org.Xwidgets.XControl;
import org.Xwidgets.XMenu;
import org.apache.log4j.Logger;
import org.x4x.plugins.Plugin;

public class PluginConnector {
	private MainGUI m;
	private HashMap menus;
	private Logger logger;
	private int added, cnt;
	
	PluginConnector(){
		m = MainGUI.mainGui;
		menus = new HashMap();
		logger = Logger.getLogger(getClass());
	}
	
	public PlaylistPanel getPlaylistPanel(){
		return m.playlistPanel;
	}
	public MlibPanel getMlibPanel(){
		return m.mlibPanel;
	}
	public ButtonBar getButtonBar(){
		return m.buttonPanel;
	}
	public void addToButtonBar(XControl b, int distance){
		b.setParent(m.buttonPanel.me);
		m.buttonPanel.fitAdd(b, distance);
		cnt++;
		if (cnt > added && m.packed){
			m.myFrame.pack();
		}
		if (cnt > added && m.buttonPanel.packed)
			m.buttonPanel.me.pack();
		added++;
	}
	public void removeFromButtonBar(XControl b){
		m.buttonPanel.lastIndex--;
		b.dispose();
		cnt--;
	}
	public XMenu getMenu(Plugin pl){
		XMenu menu = null;
		if (!menus.containsKey(pl)){
			menu = m.myGUIFactory.getMenu(m.myFrame);
			m.plugins.addMenu(menu, pl.getName());
			menus.put(pl, menu);
		}
		else {
			menu = (XMenu)menus.get(pl);
			if (menu.isDisposed()){
				logger.debug("Plugin " + pl.getName() + " didn't return it's Menu but disposed it! That's wrong");
				menu = m.myGUIFactory.getMenu(m.myFrame);
				m.plugins.addMenu(menu, pl.getName());
				menus.put(pl, menu);
			}
		}
		return menu;
	}
	
	public void returnMenu(XMenu m, Plugin pl){
		if (menus.get(pl).equals(m)){
			m.dispose();
			menus.remove(pl);
		}
	}
	public NetworkBrowser getNetworkBrowser(){
		return m.CIFSBrowser;
	}
	
}
