/******************************************************************
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Copyright:
 * Georg Schild (dangertools@gmail.com)
 * Franz Endstrasser (franz.endstrasser@gmail.com)
 ******************************************************************/

package org.x4x.gui;

import org.Xwidgets.XTableItem;
import org.apache.log4j.Logger;

public class PluginListener implements org.x4x.plugins.PluginListener {
	private Logger logger = Logger.getLogger(PluginListener.class);
	
	public void pluginActivated(String name) {
		logger.debug("Plugin " + name + " activated");
		if (MainGUI.mainGui.prefGui != null){
			for ( int i = 0; i < MainGUI.mainGui.prefGui.pluginPrefs.getItemCount(); i++){
				XTableItem xti = MainGUI.mainGui.prefGui.pluginPrefs.getItemForIndex(i);
				if (xti.getText(1).equals(name))
					xti.setChecked(true);
			}
		}
	}
	
	public void pluginDeactivated(String name) {
		logger.debug("Plugin " + name + " deactivated");
		if (MainGUI.mainGui.prefGui != null){
			for ( int i = 0; i < MainGUI.mainGui.prefGui.pluginPrefs.getItemCount(); i++){
				XTableItem xti = MainGUI.mainGui.prefGui.pluginPrefs.getItemForIndex(i);
				if (xti.getText(1).equals(name))
					xti.setChecked(false);
			}
		}
	}
	
	public void pluginStarted(String name) {
		logger.debug("Plugin " + name + " started");
	}
	
	public void pluginStopped(String name) {
		logger.debug("Plugin " + name + " stopped");
	}
	
	public void errorOccured(String name, Throwable t) {
		logger.debug("Plugin " + name + " reported error: " + t.getMessage(), t);
		if (MainGUI.mainGui.prefGui != null){
			for ( int i = 0; i < MainGUI.mainGui.prefGui.pluginPrefs.getItemCount(); i++){
				XTableItem xti = MainGUI.mainGui.prefGui.pluginPrefs.getItemForIndex(i);
				if (xti.getText(1).equals(name))
					xti.setChecked(false);
			}
		}
	}

}
